<template>
  <a
    v-if="isDesktop"
    href="#"
    class="message-item flex py-6 pl-8 items-center pr-4"
    :class="{ isUnread: message.IsUnread }"
    @click.prevent="$emit('click', message)"
  >
    <div
      class="flex flex-col w-full message-item-content ol-bo-dark-2"
      style="max-width: calc(100% - 48px)"
    >
      <div class="flex items-center w-full gap-4 message-info mb-2">
        <h5 class="overflow-hidden text-ellipsis truncate">
          {{ message.Contents?.Title }}
        </h5>
        <span class="whitespace-nowrap">{{ message.DateDisplay }}</span>
        <MessagesMessageType :type="message.TypeDisplay" />
      </div>
      <div class="message-content" v-html="message.Contents?.Content"></div>
    </div>
    <a
      href="#"
      class="w-12 h-12 flex items-center justify-center"
      @click.stop.prevent="$emit('click:delete', message)"
    >
      <ITrash class="w-4 h-4 opacity-50 text-[var(--text5)]" />
    </a>
  </a>
  <a
    v-else
    href="#"
    class="message-item flex py-2 pl-6 items-center min-h-[70px]"
    :class="{ isUnread: message.IsUnread }"
    @click.prevent="$emit('click', message)"
  >
    <div
      class="flex flex-row w-full message-item-content ol-bo-dark-2"
      style="max-width: calc(100% - 48px)"
    >
      <div class="w-full message-info flex flex-col gap-1">
        <h5 class="overflow-hidden text-ellipsis truncate">
          {{ message.Contents?.Title }}
        </h5>
        <span class="whitespace-nowrap">{{ message.DateDisplay }}</span>
        <div class="w-min">
          <MessagesMessageType :type="message.TypeDisplay" />
        </div>
      </div>
      <div class="flex items-center text-[var(--text5)] opacity-50">
        <div class="whitespace-nowrap">{{ $t("more") }}</div>
        <IArrowRight class="w-4 h-4" />
      </div>
    </div>
    <a
      href="#"
      class="w-12 h-12 flex items-center justify-center"
      @click.stop.prevent="$emit('click:delete', message)"
    >
      <ITrash class="w-4 h-4 opacity-50 text-[var(--text5)]" />
    </a>
  </a>
</template>

<script setup lang="ts">
import { MemberMessage } from "~~/models/message";
import ITrash from "~/assets/icons/trash.svg?component";
import IArrowRight from "~/assets/icons/arrow-right.svg?component";

defineEmits<{
  (e: "click", message: MemberMessage): void;
  (e: "click:delete", message: MemberMessage): void;
}>();
defineProps<{
  message: MemberMessage;
}>();
const isDesktop = useIsDesktop();
</script>

<style lang="scss">
[data-device="mobile"] .message-item {
  &.isUnread::before {
    content: "";
    position: absolute;
    top: 14px;
    left: 12px;
    width: 6px;
    height: 6px;
    border-radius: 4px;
    background: var(--failure);
  }

  .message-item-content {
    padding-right: 8px;
  }

  .message-info {
    & > h5 {
      max-width: 60vw;
    }
  }
}

.message-item {
  border-radius: 8px;
  position: relative;
  background: var(--background5);

  &.isUnread::before {
    content: "";
    position: absolute;
    top: 30px;
    left: 18px;
    width: 6px;
    height: 6px;
    border-radius: 4px;
    background: var(--failure);
  }

  .message-item-content {
    --bg-base-color: var(--border);
    padding-right: 16px;
    
    ol {
      list-style: auto; // set to auto becuae don't want to override other exsting style
      padding-left: 14px;
    }

    &::after {
      content: "";
      top: 0;
      right: 0;
      width: 1px;
      height: 100%;
      left: auto;
      background: var(--border);
    }
  }

  .arrowIcon {
    width: 16px;
    height: 16px;
  }

  .message-item-divider {
    --bg-base-color: var(--border);
    --bg-opacity: 0.3;
    position: absolute;

    width: 1px;
    height: 100%;
  }

  .message-content {
    max-height: 2.5rem;
    overflow: hidden;
    opacity: 0.8;
    font-family: Roboto;
    font-size: 12px;
    font-weight: 400;
    line-height: 18px;
    letter-spacing: 0em;
    text-align: left;

    ol {
      list-style: auto; // set to auto becuae don't want to override other exsting style
      padding-left: 14px;
    }
  }
  .message-info {
    & > h5 {
      color: var(--text5);
      font-family: Roboto;
      font-size: 12px;
      font-weight: 500;
      line-height: 14px;
      letter-spacing: 0em;
      text-align: left;
      max-width: 430px;
    }

    & > span {
      color: var(--text5);
      opacity: 0.8;
      font-family: Roboto;
      font-size: 12px;
      font-weight: 400;
      line-height: 14px;
      letter-spacing: 0em;
      text-align: left;
    }
  }
}
</style>
